#  Copyright 2021 Elia Toselli <elia.toselli@outlook.it>
#  
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#  
#  

class Point(object):
	def __init__(self, x, y):
		assert isinstance(x, (int,float)) and isinstance(y, (int,float))
		self.x = x
		self.y = y
	@staticmethod
	def distancex(a,b):
		assert isinstance(a, Point) and isinstance(b, Point)
		if a.x < b.x:
			return b.x - a.x
		else:
			return a.x -  b.x
	@staticmethod
	def distancey(a,b):
		assert isinstance(a, Point) and isinstance(b, Point)
		if a.y < b.y:
			return b.y - a.y
		else:
			return a.y -  b.y
	@staticmethod
	def distancetot(a,b):
		import math
		return math.sqrt(Point.distancex(a, b) ** 2 + Point.distancey(a, b) **2)
	def __repr__(self):
		return '('+str(self.x)+','+str(self.y)+')'
	def __str__(self):
		return self.__repr__()
	def __add__(self,b):
		assert isinstance(b, Point)
		return Point(self.x + b.x, self.y + b.y)
	def __radd__(self,b):
		assert isinstance(b, Point)
		return self.__add__(b)
	def __lt__(self,b):
		assert isinstance(b, Point)
		return self.x < b.x or self.y < b.y
	def __gt__(self,b):
		assert isinstance(b, Point)
		return self.x > b.x or self.y > b.y
	def __eq__(self,b):
		assert isinstance(b, Point)
		return self.x == b.x and self.y == b.y
	def __ne__(self,b):
		assert isinstance(b, Point)
		return not self.__eq__(b)
