#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#  
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301, USA.
#  
#  
from . import points

class Rectangle(object):
	def __init__(self, w, h, ctr):
		assert isinstance(w, (int,float))
		assert isinstance(h, (int,float))
		assert isinstance(ctr, points.Point)
		self.w = w
		self.h = h
		self.center = ctr
	def __str__(self):
		return str(self.w) + 'x' + str(self.h) + ', at ' + str(self.center)
	def __repr__(self):
		return 'Rect(' + str(self.w) + 'x' + str(self.h) + ', center= ' + str(self.center) + ')'
	def area(self):
		return self.w * self.h
	def perimeter(self):
		return 2 * (self.w + self.h)
	def __lt__(self, b):
		return self.area() < b.area()
	def __gt__(self, b):
		return self.area() > b.area()
	def __ne__(self, b):
		return self.__lt__(b) or self.__gt__(b)
	def __eq__(self, b): return not self.__ne__(b)
